net.sf.saxon.tree.tiny

## Class TinyElementImpl

- java.lang.Object
- - net.sf.saxon.tree.tiny.TinyNodeImpl
  - - net.sf.saxon.tree.tiny.TinyParentNodeImpl
    - - net.sf.saxon.tree.tiny.TinyElementImpl

- All Implemented Interfaces:
    Source, SourceLocator, PullEvent, FingerprintedNode, Item, NodeInfo, Sequence

      public final class TinyElementImpl
      extends TinyParentNodeImpl

  A node in the XML parse tree representing an XML element.

  This class is an implementation of NodeInfo. The object is a wrapper around one entry in the arrays maintained by the TinyTree. Note that the same node might be represented by different TinyElementImpl objects at different times.

  Author:
    Michael H. Kay

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.tree.tiny.TinyNodeImpl

      `NODE_LETTER, nodeNr, parent, tree`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TinyElementImpl(TinyTree tree, int nodeNr)` Constructor - create a tiny element node

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AtomicSequence` | `atomize()` Get the typed value.
    `void` | `copy(Receiver receiver, int copyOptions, int locationId)` Copy this node to a given receiver
    `String` | `getAttributeValue(int fp)` Get the value of the attribute with a given fingerprint.
    `String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
    `String` | `getBaseURI()` Get the base URI of this element node.
    `NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
    `static NamespaceBinding[]` | `getDeclaredNamespaces(TinyTree tree, int nodeNr, NamespaceBinding[] buffer)` Static method to get all namespace undeclarations and undeclarations defined on a given element, without instantiating the node object.
    `int` | `getNodeKind()` Return the type of node.
    `SchemaType` | `getSchemaType()` Get the type annotation of this node, if any.
    `int` | `getTypeAnnotation()` Get the type annotation of this node, if any Returns Type.UNTYPED_ANY if there is no type annotation
    `String` | `getURIForPrefix(String prefix, boolean useDefault)` Get the namespace URI corresponding to a given prefix.
    `boolean` | `isId()` Determine whether this node has the is-id property
    `boolean` | `isIdref()` Determine whether this node has the is-idref property

    - ### Methods inherited from class net.sf.saxon.tree.tiny.TinyParentNodeImpl

      `getStringValue, getStringValueCS, getStringValueCS, hasChildNodes`

    - ### Methods inherited from class net.sf.saxon.tree.tiny.TinyNodeImpl

      `compareOrder, comparePosition, equals, generateId, getColumnNumber, getConfiguration, getDisplayName, getDocumentNumber, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNamePool, getNodeNumber, getParent, getPrefix, getPublicId, getRoot, getSequenceNumber, getSystemId, getTree, getURI, hashCode, head, isAncestorOrSelf, isNilled, isSameNodeInfo, iterate, iterateAxis, iterateAxis, setParentNode, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TinyElementImpl

          public TinyElementImpl(TinyTree tree,
                         int nodeNr)

      Constructor - create a tiny element node
      Parameters:
        `tree` - the Tinytree containing the node
        `nodeNr` - the node number

  - ### Method Detail

    - #### getNodeKind

          public final int getNodeKind()

      Return the type of node.
      Returns:
        Type.ELEMENT
      See Also:
        `Type`

    - #### getBaseURI

          public String getBaseURI()

      Get the base URI of this element node. This will be the same as the System ID unless xml:base has been used.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Overrides:
        `getBaseURI` in class `TinyNodeImpl`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

    - #### getTypeAnnotation

          public int getTypeAnnotation()

      Get the type annotation of this node, if any Returns Type.UNTYPED_ANY if there is no type annotation
      Specified by:
        `getTypeAnnotation` in interface `NodeInfo`
      Overrides:
        `getTypeAnnotation` in class `TinyNodeImpl`
      Returns:
        the type annotation of the node, under the mask NamePool.FP_MASK, and optionally the bit setting IS_DTD_TYPE in the case of a DTD-derived ID or IDREF/S type (which is treated as untypedAtomic for the purposes of obtaining the typed value).

        For elements and attributes, this is the type annotation as defined in XDM. For document nodes, it should be one of XS_UNTYPED if the document has not been validated, or XS_ANY_TYPE if validation has taken place (that is, if any node in the document has an annotation other than Untyped or UntypedAtomic).

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Overrides:
        `getSchemaType` in class `TinyNodeImpl`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value.
      Returns:
        the typed value. It will be a Value representing a sequence whose items are atomic values.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `TinyNodeImpl`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### getDeclaredNamespaces

          public static NamespaceBinding[] getDeclaredNamespaces(TinyTree tree,
                                                 int nodeNr,
                                                 NamespaceBinding[] buffer)

      Static method to get all namespace undeclarations and undeclarations defined on a given element, without instantiating the node object.
      Parameters:
        `tree` - The tree containing the given element node
        `nodeNr` - The node number of the given element node within the tinyTree
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### getAttributeValue

          public String getAttributeValue(String uri,
                                 String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Overrides:
        `getAttributeValue` in class `TinyNodeImpl`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getAttributeValue

          public String getAttributeValue(int fp)

      Get the value of the attribute with a given fingerprint.
      Specified by:
        `getAttributeValue` in interface `FingerprintedNode`
      Overrides:
        `getAttributeValue` in class `TinyNodeImpl`
      Parameters:
        `fp` - the fingerprint of the required attribute
      Returns:
        the string value of the attribute if present, or null if absent

    - #### copy

          public void copy(Receiver receiver,
                  int copyOptions,
                  int locationId)
                    throws XPathException

      Copy this node to a given receiver
      Parameters:
        `copyOptions` -
        `receiver` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
        `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
      Throws:
        `XPathException` - if any downstream error occurs

    - #### getURIForPrefix

          public String getURIForPrefix(String prefix,
                               boolean useDefault)

      Get the namespace URI corresponding to a given prefix. Return null if the prefix is not in scope.
      Parameters:
        `prefix` - the namespace prefix. May be the zero-length string, indicating that there is no prefix. This indicates either the default namespace or the null namespace, depending on the value of useDefault.
        `useDefault` - true if the default namespace is to be used when the prefix is "". If false, the method returns "" when the prefix is "".
      Returns:
        the uri for the namespace, or null if the prefix is not in scope. The "null namespace" is represented by the pseudo-URI "".

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Overrides:
        `isId` in class `TinyNodeImpl`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Determine whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Overrides:
        `isIdref` in class `TinyNodeImpl`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.